*DECK LIBENI
      SUBROUTINE LIBENI(CFILNA,NEL)
C
C-------------------------- LIBENI   ----------------------------------
C
C  PROGRAMME STATISTICS:
C     NAME     : LIBENI
C     ENTRY    : LIBENI
C     USE      : INITIALIZE DIMENSIONS FOR DEPLETION DATA ON WIMS-D4
C                FORMAT LIBRARY
C     MODIFIED : 97-01-03
C     AUTHOR   : G. MARLEAU
C
C  ROUTINE PARAMETERS:
C   INPUT
C     CFILNA : WIMS FILE NAME                       C*8
C   OUTPUT
C     NEL    : NUMBER OF ISOTOPES ON LIBRARY        I
C   WIMS-D4 LIBRARY PARAMETERS
C     LPZ    : LENGTH OF WIMS PARAMETER ARRAY = 8   I
C     NPZ    : LIST OF MAIN PARAMETERS              I(LPZ)
C
C--------------------------  LIBENI  ----------------------------------
C
      IMPLICIT NONE
C----
C PARAMETERS
C----
      INTEGER      LRIND,IACTO,IACTC,IUTYPE,LPZ
      PARAMETER   (LRIND=0,IACTO=2,IACTC=1,IUTYPE=2,LPZ=8)
C----
C EXTERNAL FUNCTIONS
C----
      INTEGER      KDRCLS,KDROPN
C----
C LOCAL VARIABLES
C-----
      INTEGER      NEL,IUNIT,II,IERR
      CHARACTER    CFILNA*8
C----
C  WIMS-D4 LIBRARY PARAMETERS
C----
      INTEGER      NPZ(LPZ)
C----
C  OPEN WIMS-D4 LIBRARY
C  READ GENERAL DIMENSIONING
C----
      IUNIT=KDROPN(CFILNA,IACTO,IUTYPE,LRIND)
      IF(IUNIT.LE.0) CALL XABORT('LIBENI: WIMS-D4 LIBRARY '//
     >    CFILNA//' CANNOT BE OPENED FOR DEPLETION')
      READ(IUNIT) (NPZ(II),II=1,LPZ)
      NEL=NPZ(1)
      IERR=KDRCLS(IUNIT,IACTC)
      IF(IERR.LT.0)
     >  CALL XABORT('LIBENI: WIMS-D4 LIBRARY '//
     >    CFILNA//' CANNOT BE CLOSED')
C----
C  RETURN
C----
      RETURN
      END
