*DECK TLMRPI
      SUBROUTINE TLMRPI(IFTRK ,NDIM  ,NANGL ,NBTR  ,
     >                  IDUV  )
*
*-----------------------------------------------------------------------
*
*Purpose:
* To read plane identification for angles.
*
*Copyright:
* Copyright (C) 2006 Ecole Polytechnique de Montreal.
*
*Author(s):
* C. Plamondon, G. Marleau
*
*Update(s):
* None.
*
*Reference:
* None.
*
*Parameters: input
* IFTRK   pointer to the TRACKING file.
* NDIM    number of dimensions for problem.
* NANGL   number of angles.
* NBTR    numbre of tracks.
*
*Parameters: output
* IDUV    plane identification for lines
*
*----------
*
      IMPLICIT         NONE
*----
*  Subroutine arguments
*----
      INTEGER          IFTRK
      INTEGER          NDIM,NANGL,NBTR
      INTEGER          IDUV(3,NANGL,4)
*----
*  Local parameters
*----
      INTEGER          IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,NAMSBR='TLMRPI')
*----
*  Local variables
*----
      INTEGER          ILINE,IANGL,NBSEG,NUM,ISEG,
     >                 NTLINE,IPLANE,IPTA2,IPTA3,IDIR
      DOUBLE PRECISION WEIGHT,XL,TORIG(3),TSTRT
*----
*  Processing starts:
*  initialize IDUV
*  and initialize various parameters.
*----
      CALL XDISET(IDUV,3*NANGL*4,0)
      DO ILINE=1,NBTR
        READ(IFTRK) IANGL,NBSEG,WEIGHT,
     >  (NUM,ISEG=1,NBSEG),
     >  (XL,ISEG=1,NBSEG),
     >  NTLINE,IPLANE,IPTA2,IPTA3,
     >  (TORIG(IDIR),IDIR=1,NDIM),TSTRT
        IF(IPLANE .EQ. 1) THEN
          IF(IDUV(1,IANGL,1) .EQ. 0 .OR.
     >       IPTA2 .LT. IDUV(1,IANGL,1)) THEN
            IDUV(1,IANGL,1)=IPTA2
          ENDIF
          IF(IPTA2 .GT. IDUV(1,IANGL,2)) IDUV(1,IANGL,2)=IPTA2
          IF(NDIM .EQ. 3) THEN
            IF(IDUV(1,IANGL,3) .EQ. 0 .OR.
     >         IPTA3 .LT. IDUV(1,IANGL,3)) THEN
              IDUV(1,IANGL,3)=IPTA3
            ENDIF
            IF(IPTA3 .GT. IDUV(1,IANGL,4)) IDUV(1,IANGL,4)=IPTA3
          ENDIF
        ELSE IF(IPLANE .EQ. 2) THEN ! DEUXIEME PLAN
          IF(IDUV(2,IANGL,1) .EQ. 0 .OR.
     >       IPTA2 .LT. IDUV(2,IANGL,1)) THEN
            IDUV(2,IANGL,1)=IPTA2
          ENDIF
          IF(IPTA2 .GT. IDUV(2,IANGL,2)) IDUV(2,IANGL,2)=IPTA2
          IF(NDIM .EQ. 3) THEN
            IF(IDUV(2,IANGL,3) .EQ. 0 .OR.
     >         IPTA3 .LT. IDUV(2,IANGL,3)) THEN
              IDUV(2,IANGL,3)=IPTA3
            ENDIF
            IF(IPTA3 .GT. IDUV(2,IANGL,4)) THEN
              IDUV(2,IANGL,4)=IPTA3
            ENDIF
          ENDIF
        ELSE IF(IPLANE .EQ. 3) THEN
          IF(IDUV(3,IANGL,1) .EQ. 0 .OR.
     >       IPTA2 .LT. IDUV(3,IANGL,1)) THEN
            IDUV(3,IANGL,1)=IPTA2
          ENDIF
          IF(IPTA2 .GT. IDUV(3,IANGL,2)) THEN
            IDUV(3,IANGL,2)=IPTA2
          ENDIF
          IF(NDIM .EQ. 3) THEN
            IF(IDUV(3,IANGL,3) .EQ. 0 .OR.
     >         IPTA3 .LT. IDUV(3,IANGL,3)) THEN
              IDUV(3,IANGL,3)=IPTA3
            ENDIF
            IF(IPTA3 .GT. IDUV(3,IANGL,4)) THEN
              IDUV(3,IANGL,4)=IPTA3
            ENDIF
          ENDIF
        ENDIF
      ENDDO
*----
*  Processing finished, return
*----
      RETURN
      END
